Class UmlBaseClass

Declaration :

- C++ : class UmlBaseClass : public UmlClassMember
- Java : abstract class UmlBaseClass extends UmlClassMember

Directly inherited by : UmlClass

Manage the classes

Artifact : UmlBaseClass

Operation create

Declaration :

- C++ : public: static UmlClass * create(UmlItem * parent, const char * s)
- Java : public static UmlClass create(UmlItem parent, String s) throws RuntimeException

returns a new class named 's' created under 'parent'
In case it cannot be created (the name is already used or
invalid, 'parent' cannot contain it etc ...) return 0 in C++
and produce a RuntimeException in Java

Operation kind

Declaration :

- C++ : public: virtual anItemKind kind()
- Java : public anItemKind kind()

returns the kind of the item

Operation isAbstract

Declaration :

- C++ : public: bool isAbstract()
- Java : public boolean isAbstract()

returns TRUE in case the class is abstract

Operation set_isAbstract

Declaration :

- C++ : public: bool set_isAbstract(bool y)
- Java : public void set_isAbstract(boolean y) throws RuntimeException

the set if the class is abstract
On error return FALSE in C++, produce a RuntimeException in Java,
for instance you cannot set it to FALSE in case the class have
abstract operations

Operation baseType

Declaration :

- C++ : public: const UmlTypeSpec & baseType()
- Java : public UmlTypeSpec baseType()

returns the type on which the class (in fact a typedef) is based

Operation set_BaseType

Declaration :

- C++ : public: bool set_BaseType(const UmlTypeSpec & t)
- Java : public void set_BaseType(UmlTypeSpec t) throws RuntimeException

to set the type on which the class (in fact a typedef) is based
On error return FALSE in C++, produce a RuntimeException in Java, does not check that the class is (already) a typedef

Operation formals

Declaration :

- C++ : public: QValueList<UmlFormalParameter> formals()
- Java : public UmlFormalParameter[] formals()

returns (a copy of) the formals list

Operation removeFormal

Declaration :

- C++ : public: bool removeFormal(unsigned int rank)
- Java : public void removeFormal(int rank) throws RuntimeException

remove the formal of the given rank (0...), returns 0 on error
On error return FALSE in C++, produce a RuntimeException in Java,
does not check that the class is (already) a typedef

Operation addFormal

Declaration :

- C++ : public: bool addFormal(unsigned int rank, const UmlFormalParameter & formal)
- Java : public void addFormal(int rank, UmlFormalParameter formal) throws RuntimeException

adds a formal at the given rank (0...), returns 0 on error
On error return FALSE in C++, produce a RuntimeException in Java,
does not check that the class is (already) a typedef

Operation replaceFormal

Declaration :

- C++ : public: bool replaceFormal(unsigned int rank, const UmlFormalParameter & formal)
- Java : public void replaceFormal(int rank, UmlFormalParameter formal) throws RuntimeException

replace the formal at the given rank (0...)
On error return FALSE in C++, produce a RuntimeException in Java,
does not check that the class is (already) a typedef

Operation actuals

Declaration :

- C++ : public: QValueList<UmlActualParameter> actuals()
- Java : public UmlActualParameter[] actuals()

returns (a copy of) the actuals list

Operation replaceActual

Declaration :

- C++ : public: bool replaceActual(unsigned int rank, const UmlTypeSpec & type)
- Java : public void replaceActual(int rank, UmlTypeSpec type) throws RuntimeException

replace the actual value at the given rank (0...)
On error return FALSE in C++, produce a RuntimeException in Java

Operation associatedDiagram

Declaration :

- C++ : public: UmlClassDiagram * associatedDiagram()
- Java : public UmlClassDiagram associatedDiagram()

returns the optional associated diagram

Operation set_AssociatedDiagram

Declaration :

- C++ : public: bool set_AssociatedDiagram(UmlClassDiagram * d)
- Java : public void set_AssociatedDiagram(UmlClassDiagram d) throws RuntimeException

sets the associated diagram, arg may be null to unset it
On error return FALSE in C++, produce a RuntimeException in Java

Operation associatedArtifact

Declaration :

- C++ : public: UmlArtifact * associatedArtifact()
- Java : public UmlArtifact associatedArtifact()

returns the optional associated artifact,
to set it refer to the UmlBaseArtifact's operations
addAssociatedClass(), removeAssociatedClass() and
setAssociatedClasses()

Operation associatedComponents

Declaration :

- C++ : public: const QVector<UmlComponent> associatedComponents()
- Java : public UmlComponent[] associatedComponents()

returns the components realizing or providing the class.
To set them refer to the UmlBaseComponent's operation setAssociatedClasses()

Operation isCppExternal

Declaration :

- C++ : public: bool isCppExternal()
- Java : public boolean isCppExternal()

returns TRUE if the class is external, its definition
must contains how the name is made on the first line
(isCppExternal by default), the other lines if they exist
must contains the #include and may be using forms

Operation set_isCppExternal

Declaration :

- C++ : public: bool set_isCppExternal(bool y)
- Java : public void set_isCppExternal(boolean y) throws RuntimeException

set if the class is external
On error return FALSE in C++, produce a RuntimeException in Java

Operation isJavaExternal

Declaration :

- C++ : public: bool isJavaExternal()
- Java : public boolean isJavaExternal()

returns TRUE if the class is external, its definition
must contain how the name is made on the first line
(isJavaExternal by default), the other lines are ignored

Operation set_isJavaExternal

Declaration :

- C++ : public: bool set_isJavaExternal(bool y)
- Java : public void set_isJavaExternal(boolean y) throws RuntimeException

set if the class is external
On error return FALSE in C++, produce a RuntimeException in Java

Operation isJavaPublic

Declaration :

- C++ : public: bool isJavaPublic()
- Java : public boolean isJavaPublic()

returns TRUE is the class is public

Operation set_isJavaPublic

Declaration :

- C++ : public: bool set_isJavaPublic(bool y)
- Java : public void set_isJavaPublic(boolean y) throws RuntimeException

set if the class is public
On error return FALSE in C++, produce a RuntimeException in Java

Operation isJavaFinal

Declaration :

- C++ : public: bool isJavaFinal()
- Java : public boolean isJavaFinal()

returns TRUE is the class is final

Operation set_isJavaFinal

Declaration :

- C++ : public: bool set_isJavaFinal(bool y)
- Java : public void set_isJavaFinal(boolean y) throws RuntimeException

set if the class is final
On error return FALSE in C++, produce a RuntimeException in Java

Operation switchType

Declaration :

- C++ : public: const UmlTypeSpec & switchType()
- Java : public UmlTypeSpec switchType()

returns the switch's type, significant in case the class
is an union in IDL

Operation set_SwitchType

Declaration :

- C++ : public: bool set_SwitchType(const UmlTypeSpec & t)
- Java : public void set_SwitchType(UmlTypeSpec t) throws RuntimeException

to set the switch type even the class is not (already) an IDL union
On error return FALSE in C++, produce a RuntimeException in Java

Operation isIdlExternal

Declaration :

- C++ : public: bool isIdlExternal()
- Java : public boolean isIdlExternal()

returns TRUE if the class is external, its definition
must contain how the name is made on the first line
(isIdlExternal by default), the other lines are ignored

Operation set_isIdlExternal

Declaration :

- C++ : public: bool set_isIdlExternal(bool y)
- Java : public void set_isIdlExternal(boolean y) throws RuntimeException

set if the class is external
On error return FALSE in C++, produce a RuntimeException in Java

Operation isIdlLocal

Declaration :

- C++ : public: bool isIdlLocal()
- Java : public boolean isIdlLocal()

returns TRUE if the class is local, have sense for an interface

Operation set_isIdlLocal

Declaration :

- C++ : public: bool set_isIdlLocal(bool y)
- Java : public void set_isIdlLocal(boolean y) throws RuntimeException

set if the class is local, have sense for an interface
On error return FALSE in C++, produce a RuntimeException in Java

Operation isIdlCustom

Declaration :

- C++ : public: bool isIdlCustom()
- Java : public boolean isIdlCustom()

returns TRUE is the class is custom, have sense for a valuetype

Operation set_isIdlCustom

Declaration :

- C++ : public: bool set_isIdlCustom(bool y)
- Java : public void set_isIdlCustom(boolean y)

set if the class is custom have sense for aa valuetype
On error return FALSE in C++, produce a RuntimeException in Java

Operation get

Declaration :

- C++ : public: static UmlClass * get(const QCString & n, const UmlPackage * p)
- Java : public static UmlClass get(String n, UmlPackage p)

returns the class having the name given in argument in case it
exist, else 0/null. In case the package is specified (not 0/null),
the returned class will be defined in a sub-level of the package.

Operation unload

Declaration :

- C++ : public: virtual void unload(bool rec = FALSE, bool del = FALSE)
- Java : public void unload(boolean rec, boolean del)

to unload the object to free memory, it will be reloaded automatically
if needed. Recursively done for the sub items if 'rec' is TRUE.
if 'del' is true the sub items are deleted in C++, and removed from the
internal dictionnary in C++ and Java (to allow it to be garbaged),
you will have to call Children() to re-access to them

Operation set_Name

Declaration :

- C++ : public: virtual bool set_Name(const QCString & s)
- Java : public void set_Name(String s) throws RuntimeException

to set the name
On error return FALSE in C++, produce a RuntimeException in Java

Attribut _classes

Declaration :

- C++ : private: static QDict<UmlClass> _classes
- Java : private static Hashtable _classes

Extra Class Member initialization

Definition :

- Java :

        static { _classes = new Hashtable(1001); }

Attribut _abstract

Declaration :

- C++ : private: bool _abstract
- Java : private boolean _abstract

Attribut _cpp_external

Declaration :

- C++ : private: bool _cpp_external : 1
- Java : private boolean _cpp_external

Attribut _java_external

Declaration :

- C++ : private: bool _java_external : 1
- Java : private boolean _java_external

Attribut _java_public

Declaration :

- C++ : private: bool _java_public
- Java : private boolean _java_public

Attribut _java_final

Declaration :

- C++ : private: bool _java_final
- Java : private boolean _java_final

Attribut _idl_external

Declaration :

- C++ : private: bool _idl_external
- Java : private boolean _idl_external

Attribut _idl_local

Declaration :

- C++ : private: bool _idl_local
- Java : private boolean _idl_local

Attribut _idl_custom

Declaration :

- C++ : private: bool _idl_custom
- Java : private boolean _idl_custom

Relation _base_type (<directional aggregation by value>)

Declaration :

- C++ : private: UmlTypeSpec _base_type
- Java : private UmlTypeSpec _base_type

Relation _assoc_diagram (<unidirectional association>)

Declaration :

- C++ : private: UmlClassDiagram * _assoc_diagram
- Java : private UmlClassDiagram _assoc_diagram

Relation _switch_type (<directional aggregation by value>)

Declaration :

- C++ : private: UmlTypeSpec _switch_type
- Java : private UmlTypeSpec _switch_type

union

Operation UmlBaseClass

Declaration :

- C++ : protected: UmlBaseClass(void * id, const QCString & n)
- Java : protected UmlBaseClass(long id, String n)

the constructor, do not call it yourself !!!!!!!!!!

Operation read_uml_

Declaration :

- C++ : protected: virtual void read_uml_()
- Java : protected void read_uml_()

internal, do NOT use it

Operation read_cpp_

Declaration :

- C++ : protected: virtual void read_cpp_()
- Java : protected void read_cpp_()

internal, do NOT use it

Operation read_java_

Declaration :

- C++ : protected: virtual void read_java_()
- Java : protected void read_java_()

internal, do NOT use it

Operation read_idl_

Declaration :

- C++ : protected: virtual void read_idl_()
- Java : protected void read_idl_()

internal, do NOT use it

Operation reread_if_needed_

Declaration :

- C++ : protected: void reread_if_needed_()
- Java : protected void reread_if_needed_()

internal, do NOT use it

All public operations : actuals , addFormal , apply , associatedArtifact , associatedComponents , associatedDiagram , baseType , children , childrenVisible , cppDecl , cppVisibility , create , defined_ , description , formals , get , identifier_ , idlDecl , isAbstract , isClassMember , isCppExternal , isIdlCustom , isIdlExternal , isIdlLocal , isJavaExternal , isJavaFinal , isJavaPublic , isMarked , isToolRunning , isVolatile , isWritable , javaAnnotations , javaDecl , kind , kind , markedItems , moveAfter , name , parent , properties , propertyValue , referencedBy , removeFormal , replaceActual , replaceFormal , set_AssociatedDiagram , set_BaseType , set_childrenVisible , set_CppDecl , set_CppVisibility , set_Description , set_IdlDecl , set_isAbstract , set_isClassMember , set_isCppExternal , set_isIdlCustom , set_isIdlExternal , set_isIdlLocal , set_isJavaExternal , set_isJavaFinal , set_isJavaPublic , set_isMarked , set_isVolatile , set_JavaAnnotations , set_JavaDecl , set_Name , set_Name , set_PropertyValue , set_Stereotype , set_SwitchType , set_Visibility , stereotype , supportFile , switchType , unload , unload , unload , visibility